﻿using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;
using Syncfusion.XForms.DataForm;
using System.Collections;
using System.ComponentModel;
using Syncfusion.XForms.DataForm.Editors;
using Syncfusion.XForms.ComboBox;

namespace DataFormDropDown
{
    public class DataFormBehavior : Behavior<ContentPage>
    {
        SfDataForm dataForm;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            dataForm = bindable.FindByName<SfDataForm>("dataForm");
            dataForm.SourceProvider = new SourceProviderContactForm();
            dataForm.DataObject = new Address();
           
            (dataForm.DataObject as INotifyPropertyChanged).PropertyChanged += DataFormBehavior_PropertyChanged;

            dataForm.RegisterEditor("DropDown", new CustomDropDownEditor(dataForm));
            dataForm.RegisterEditor("City", "DropDown");
            dataForm.RegisterEditor("Country", "DropDown");
        }

        private void DataFormBehavior_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Country")
            {
                var item = sender as Address;
                if (item.Country.Equals("Canada"))
                {
                    var list = new List<string>();
                    list.Add("Ottawa");
                    list.Add("Toronto");
                    (dataForm.ItemManager.DataFormItems["City"] as DataFormDropDownItem).ItemsSource = list;
                    item.City = "Toronto";
                    dataForm.UpdateEditor("City");
                }

                else if (item.Country.Equals("Argentina"))
                {
                    var list = new List<string>();
                    list.Add("Buenos Aires");
                    list.Add("Mendoza");
                    list.Add("Salta");

                    (dataForm.ItemManager.DataFormItems["City"] as DataFormDropDownItem).ItemsSource = list;
                    item.City = "Buenos Aires";
                    dataForm.UpdateEditor("City");
                }

                else if (item.Country.Equals("Brazil"))
                {
                    var list = new List<string>();
                    list.Add("Rio de Janeiro");
                    list.Add("Salvador");
                    list.Add("Manaus");
                    (dataForm.ItemManager.DataFormItems["City"] as DataFormDropDownItem).ItemsSource = list;
                    item.City = "Rio de Janeiro";
                    dataForm.UpdateEditor("City");
                }
            }
        }

    }
    public class SourceProviderContactForm : SourceProvider
    {
        public override IList GetSource(string sourceName)
        {
            var list = new List<string>();
            if (sourceName == "City")
            {
                list.Add("Item1");
                list.Add("Item2");
            }

            else if (sourceName == "Country")
            {
                list.Add("Canada");
                list.Add("Argentina");
                list.Add("Brazil");
            }
            return list;
        }
    }

    public class CustomDropDownEditor : DataFormDropDownEditor
    {
        public CustomDropDownEditor(SfDataForm dataForm) : base(dataForm)
        {

        }
        protected override void OnInitializeView(DataFormItem dataFormItem, SfComboBox view)
        {
            base.OnInitializeView(dataFormItem, view);
            view.IsEditableMode = true;
        }
    }
}
